<template>
  <div style="margin: 3rem">
     <header style="margin:10rem 6rem 3rem 6rem">
        <ReturnButton :offsetArrow="20" :spanTitle="3" title="Ir a Materiales" v-on:clickEvent="viewListReview" style="margin-bottom:2.5rem"></ReturnButton>
         <el-row :gutter="20">
          <!-- FILTROS DE BUSQUEDA --> 
            <el-col :span="18" class="text-end">
              <app-select v-model="filterSelect" :filterArray="allFilters"></app-select>
            </el-col>
            <el-col :span="6">
              <app-search-filter v-model="textSearch"></app-search-filter>
            </el-col>  
        </el-row>
      </header>
      <!-- COMPONENTE TITULO -->
      <div style="margin:3rem 6rem">
        <Title :Title="'REVISION DE '+ matType + ' - '+typeMaterialR.toUpperCase()"> </Title>
      </div>

      <!-- CUADRADITOS DE INFORMACION DEL ESTADO DE LOS PEDIDOS -->
      <div style="margin:3rem 6rem">
        <DescriptionStateOrders TextSquareGray="Sin Revisar" TextSquareGreen="Aprobado y Al aire" TextSquareBlue="Aprobado, pero no emitido" :TextSquareRed="''" TextSquareOrange="Aprobado y Emitido" :colBoxes="6"> </DescriptionStateOrders>
      </div>

      <el-main style="margin:3rem 5rem">
        <el-row>
          <el-col 
            v-for="(material, index) in materials.slice(0,30)"
            :key="index"
            :span="18" :offset="3"
            style="margin-bottom: 4rem">

            <app-card-review 
              :showRate="true" :itemPrincipal="material" :shadowBox="'pink-shadow'" :imgStyle="'icon-card'"
              :detailsData="getDetailData(material)"
              :detailsData2="getDetailData2(material)"
              :btnGroup="{
                0:{validationBtnShow: material.reviewStatus === 'withoutChecking', btnClass: 'border-grey-darken text-dark-gray-2', btnTextAction: 'SIN REVISAR', editVal: 'selectedMaterial', newVal: 'revFusionGourmet'},  
                1:{validationBtnShow: material.reviewStatus === 'approved2', btnClass: 'border-blue text-blue', btnTextAction: 'NO EMITIDO', editVal: 'selectedMaterial', newVal: 'reportFusionGourmet'},
                2:{validationBtnShow: material.reviewStatus === 'live',btnClass: 'border-green text-green', btnTextAction: 'AL AIRE', editVal: 'selectedMaterial', newVal: 'reportFusionGourmet'},
                3:{validationBtnShow: material.reviewStatus === 'transmitted', btnClass: 'border-orange text-orange', btnTextAction: 'EMITIDO', editVal: 'selectedMaterial', newVal: 'reportFusionGourmet'},
                4: {validationBtnShow: material.reviewStatus === 'incompleteStyle', btnClass: 'b-purple t-purple', btnTextAction: 'INCOMPLETO', editVal: 'selectedMaterial', newVal: 'reportFusionGourmet'}
              }"/>
          </el-col>
        </el-row>
      </el-main>
  </div>
</template>

<script>
import ReturnButton from '@/components/ReturnButton.vue'
import CardReview from '@/components/cardReview'
import SearchFilter from '@/components/searchFilter.vue'
import Select from '@/components/AppSelect.vue'
import Title from '@/components/Title.vue'  
import DescriptionStateOrders from '@/components/DescriptionStateOrders.vue' 
import { HTTP } from '@/main.js'
import { modifyText } from '@/utils/modifyText.js'

export default {
  components: {
    ReturnButton,
    'app-card-review': CardReview,
    'app-search-filter': SearchFilter,
    'app-select': Select,
     Title,
     DescriptionStateOrders
  },
  data () {
    return {
      returnButtonModal: false,
      score: 4.8,
      filterSelect: '',
      textSearch: '',
      allFilters: [
        {value: 'providerCode', label: 'Proveedor'},
        {value: 'codMaterial', label: 'Código de Material'}
      ],
      typeMaterialR: localStorage.getItem('typeMaterialR'),
      enlatado: localStorage.getItem('enlatado'),
      allMaterials: [],
      confirmedStatus: '',
      matType: localStorage.getItem('classification'),
      listGenders: []
    }
  },
   created () {
    this.getMaterials()
  },
  computed: {
    materials () {
     let movies = this.allMaterials
      if (this.textSearch) {
        movies = this.allMaterials.filter(
          m => modifyText(m.originalTitle).indexOf(modifyText(this.textSearch)) > -1) ||
                modifyText(m.ownTitle).indexOf(modifyText(this.textSearch)) > -1 ||
                modifyText(m.listTitle).indexOf(modifyText(this.textSearch)) > -1 
      }

      if (this.filterSelect && this.textSearch) {
        movies = this.allMaterials.filter(
          m => modifyText(m[this.filterSelect]).indexOf(modifyText(this.textSearch)) !== -1)
      }

      movies.sort(function(a, b){
        console.log(a,'a')
        console.log(b,'b')
        return b.geminisCode - a.geminisCode
      })

      return movies
    }
  },
  methods: {
    getMaterials() {
      HTTP.get('materials/materialType/' + this.typeMaterialR + '/canned/false' )
        .then(res => {
          this.allMaterials = res.data.materials
        })
      .catch(err => console.log(err))
    },
    viewListReview () {
      this.$router.push({name: 'produccionNacional', params: { canned: false } })
    },
    verificateGender(val) {
      let genero = val && val.length > 0 ? val : []
      let nombres = []
      genero.forEach((el) => {
        this.listGenders.filter((e) => {
          if (el == e.code) {
            nombres.push(e.name)
          }
        })
      })
      return nombres
    },
    getDetailData(material) {
      let obj = {
        0:{subtitle: 'Código de Material', content: material.codMaterial},
        1:{subtitle: 'Proveedor', content: material.providerName},
        2:{subtitle: 'Temporada', content: (material.numChapters.map(i => i.season)).join(' - ')},
      }
      return obj
    },
    getDetailData2(material) {
      let obj = {
        0:{subtitle: 'Género', content: this.verificateGender(material.genre).length > 0 ? this.verificateGender(material.genre).toString().replace(/,/gi, ', ') : `Sin género asignado.` },
        1:{subtitle: 'Clasificación', content: material.classification}
      }
      return obj
    }
  },
  async beforeMount() {
    const {data}=  await HTTP.get(`materials/list/genres`)
    this.listGenders = data.listGenders
  }
}
</script>

<style>
.pink-shadow{
  box-shadow: 5px 5px 10px #db3f5459 !important;
}
.border-blue { /* Para los botones */
  border: 1.5px solid var(--color-blue-darken)!important;
}
.text-blue {
 color: var(--color-blue-darken)!important;
}
</style>